unit LTR43_UNIT_TEST;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,  ltrapidefine, ltrapitypes, ltrapi,ltr43api,
  Spin;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Button1: TButton;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    ComboBox2: TComboBox;
    GroupBox2: TGroupBox;
    Splitter1: TSplitter;
    GroupBox3: TGroupBox;
    ComboBox3: TComboBox;
    Button2: TButton;
    CheckBox1: TCheckBox;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    Button3: TButton;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    ComboBox6: TComboBox;
    ComboBox7: TComboBox;
    ComboBox8: TComboBox;
    ComboBox9: TComboBox;
    ComboBox10: TComboBox;
    ComboBox11: TComboBox;
    ComboBox12: TComboBox;
    Button4: TButton;
    GroupBox4: TGroupBox;
    Edit1: TEdit;
    Label3: TLabel;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Memo1: TMemo;
    ComboBox13: TComboBox;
    ComboBox14: TComboBox;
    ComboBox15: TComboBox;
    ComboBox16: TComboBox;
    Timer1: TTimer;
    Edit2: TEdit;
    Edit3: TEdit;
    Timer2: TTimer;
    Timer3: TTimer;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    Timer4: TTimer;
    Timer5: TTimer;
    Timer6: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure Timer4Timer(Sender: TObject);
    procedure Timer5Timer(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Timer6Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  STTR=^string;
var
  Form1: TForm1;
  LTRONLINE:bool;
  LTR43ONLINE:bool;
  LTR:TLTR;
  CSNLIST:array[0..CRATE_MAX-1,0..SERIAL_NUMBER_SIZE-1]of char;
  CrateNom   :byte;
  CrateSelect:byte;
  Total43:byte;
  LIST43:array[0..MODULE_MAX-1]of byte;
  LTR43SELECT:byte;
  LTR43:TLTR43;
  err:integer;
  DATA_BUF :array[0..200000]of cardinal;
  TMARK_BUF:array[0..200000]of cardinal;
  GODCounter:integer;
implementation

{$R *.dfm}

function IntTohexchar(Val:integer;N:byte):byte;
begin
       Val:=(Val shr (N*4))and $F;
       if val<10 then IntTohexchar:=48+val else IntTohexchar:=55+val;
end;


function TESTERROR(ERROR:integer;MEMO:Tmemo;STR:string):boolean;
begin
  TESTERROR:=false;
  if(memo.lines.Count>10000)then memo.Lines.Clear;
  if(ERROR<LTR_OK)then
  begin
     Memo.Lines.Add( STR+' :  '+ Inttostr(ERROR));
     TESTERROR:=true;
  end
  else
  begin
     Memo.Lines.Add( STR+' :  ');
  end
end;
procedure TForm1.Button1Click(Sender: TObject);
var i:byte;
    S:String;
    MID:array[0..MODULE_MAX-1]of WORD;
begin
  //  43-,   .
  if LTR43ONLINE then
  begin
     LTR43_Close(@LTR43);
  end;
  //  LTR,   .
  if LTRONLINE then
  begin
     err:=LTR_Close(@LTR);
     if TESTERROR(err,memo1,'  ')then exit;

     LTRONLINE:=false;
  end;
  //       (LocalHost 127.0.0.1)
    for i:=0 to CRATE_MAX-1 do CSNLIST[i]:='';
    LTR_Init(@LTR);
    err:=LTR_Open(@LTR);                    if TESTERROR(err,memo1,'  ')then exit;
    err:=LTR_GetCrates(@LTR,@CSNLIST[0,0]); if TESTERROR(err,memo1,'    ')then exit;
    err:=LTR_Close(@LTR);                   if TESTERROR(err,memo1,'  ')then exit;
    //  
    CrateNom:=0;
    CrateSelect:=0;
    Combobox1.Items.Clear;
    For i:=0 to CRATE_MAX-1 do
    if(CSNLIST[i]<>'')then
    begin
       Combobox1.Items.Add(CSNLIST[i]);
       CrateNom:=CrateNom+1;
    end;
    Combobox1.ItemIndex:=CrateSelect;
  //    
  LTR_Init(@LTR);
  for i:=0 to SERIAL_NUMBER_SIZE-1 do
  LTR.csn[i]:=CSNLIST[CrateSelect][i];

  err:=LTR_Open(@LTR);                    if TESTERROR(err,memo1,'  ')then exit;
  err:=LTR_GetCrateModules(@LTR,@MID[0]); if TESTERROR(err,memo1,'   ')then exit;
  Total43:=0;
  //  
  Combobox2.Items.Clear;
  for i:=0 to MODULE_MAX-1 do
    if MID[i]=MID_LTR43 then
    begin
       Combobox2.Items.Add(IntToStr(i));
       LIST43[Total43]:=i;
       Total43:=Total43+1;
    end;
   LTR43SELECT:=0;
   Combobox2.ItemIndex:=LTR43SELECT;
  //   
  LTR43_Init(@LTR43);
  err:=LTR43_Open(@LTR43,LTR.saddr,LTR.sport,@CSNLIST[CrateSelect][0],LIST43[LTR43SELECT]+1);
  if TESTERROR(err,memo1,'  ')then
  begin
     Groupbox2.Visible:=false;
     if(err<>-10)then exit else
     begin
       Groupbox2.Visible:=true;
       LTR43ONLINE:=true;
     end;
  end
  else
  begin
    Groupbox2.Visible:=true;
    LTR43ONLINE:=true;
  end;

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //  43-,   .
  if LTR43ONLINE then
  begin
     LTR43_Close(@LTR43);
  end;
  //  LTR,   .
  if LTRONLINE then
  begin
     err:=LTR_Close(@LTR);
     if TESTERROR(err,memo1,'  ')then exit;
     LTRONLINE:=false;
  end;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var i:byte;
    S:String;
    MID:array[0..MODULE_MAX-1]of WORD;
begin
 //  43-,   .
  if LTR43ONLINE then
  begin
     LTR43_Close(@LTR43);
  end;
  CrateSelect:=Combobox1.ItemIndex;
  //    
  LTR_Init(@LTR);
  for i:=0 to SERIAL_NUMBER_SIZE-1 do
  LTR.csn[i]:=CSNLIST[CrateSelect][i];
  err:=LTR_Open(@LTR);                    if TESTERROR(err,memo1,'  ')then exit;
  err:=LTR_GetCrateModules(@LTR,@MID[0]); if TESTERROR(err,memo1,'    43')then exit;
  Total43:=0;
  //  
  Combobox2.Items.Clear;
  for i:=0 to MODULE_MAX-1 do
    if MID[i]=MID_LTR43 then
    begin
       Combobox2.Items.Add(IntToStr(i));
       LIST43[Total43]:=i;
       Total43:=Total43+1;
    end;
   LTR43SELECT:=0;
   Combobox2.ItemIndex:=LTR43SELECT;
  //   
  LTR43_Init(@LTR43);
  err:=LTR43_Open(@LTR43,LTR.saddr,LTR.sport,@CSNLIST[CrateSelect][0],LIST43[LTR43SELECT]+1);
  if TESTERROR(err,memo1,'  43')then
  begin
     Groupbox2.Visible:=false;
     exit;
  end
  else
  begin
    Groupbox2.Visible:=true;
    LTR43ONLINE:=true;
  end;
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
 //  43-,   .
  if LTR43ONLINE then
  begin
     LTR43_Close(@LTR43);
  end;
  LTR43SELECT:=Combobox2.ItemIndex;
  //   
  LTR43_Init(@LTR43);
  err:=LTR43_Open(@LTR43,LTR.saddr,LTR.sport,@CSNLIST[CrateSelect][0],LIST43[LTR43SELECT]+1);
  if TESTERROR(err,memo1,'  43')then 
  begin
     Groupbox2.Visible:=false;
     exit;
  end
  else
  begin
    Groupbox2.Visible:=true;
    LTR43ONLINE:=true;
  end;
end;
//  .
procedure TForm1.Button2Click(Sender: TObject);
begin
    LTR43.Marks.StartMark_Mode:=Combobox3.ItemIndex;
    LTR43.Marks.SecondMark_Mode:=Combobox4.ItemIndex;
    err:=LTR43_Config(@LTR43);
    if TESTERROR(err,memo1,'  43')then exit;
    err:=LTR43_MakeStartMark(@LTR43);
    if TESTERROR(err,memo1,'   ')then exit
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
    if(Checkbox1.Checked)
    then
      begin
        LTR43.Marks.StartMark_Mode:=Combobox3.ItemIndex;
        LTR43.Marks.SecondMark_Mode:=Combobox4.ItemIndex;
        LTR43_Config(@LTR43);
        if TESTERROR(err,memo1,'  43')then exit;
        LTR43_StartSecondMark(@LTR43);
        if TESTERROR(err,memo1,'   ""')then exit

      end
    else
      begin
        LTR43_StopSecondMark(@LTR43);
        if TESTERROR(err,memo1,'   ')then exit
      end;

end;

procedure TForm1.Button3Click(Sender: TObject);
var DATA:integer;
begin
    LTR43.IO_Ports.Port1:=Combobox13.ItemIndex;
    LTR43.IO_Ports.Port2:=Combobox13.ItemIndex;
    LTR43.IO_Ports.Port3:=Combobox13.ItemIndex;
    LTR43.IO_Ports.Port4:=Combobox13.ItemIndex;
    err:=LTR43_Config(@LTR43);
    if TESTERROR(err,memo1,'  43')then exit;
    DATA:=ComboBox5.ItemIndex;
    DATA:=DATA+ComboBox6.ItemIndex shl 4;
    DATA:=DATA+ComboBox7.ItemIndex shl 8;
    DATA:=DATA+ComboBox8.ItemIndex shl 12;
    DATA:=DATA+ComboBox9.ItemIndex shl 16;
    DATA:=DATA+ComboBox10.ItemIndex shl 20;
    DATA:=DATA+ComboBox11.ItemIndex shl 24;
    DATA:=DATA+ComboBox12.ItemIndex shl 28;
    err:=LTR43_WritePort(@LTR43,DATA);
    if TESTERROR(err,memo1,'  ')then exit

end;

procedure TForm1.Button4Click(Sender: TObject);
var DATA:integer;
begin
    LTR43.IO_Ports.Port1:=Combobox13.ItemIndex;
    LTR43.IO_Ports.Port2:=Combobox13.ItemIndex;
    LTR43.IO_Ports.Port3:=Combobox13.ItemIndex;
    LTR43.IO_Ports.Port4:=Combobox13.ItemIndex;
    err:=LTR43_Config(@LTR43);
    if TESTERROR(err,memo1,'  43')then exit;
    err:=LTR43_ReadPort(@LTR43,@DATA);
    if TESTERROR(err,memo1,'  ')then exit;
    ComboBox12.ItemIndex:=(DATA shr 28)and $F;
    ComboBox11.ItemIndex:=(DATA shr 24)and $F;
    ComboBox10.ItemIndex:=(DATA shr 20)and $F;
    ComboBox9.ItemIndex:= (DATA shr 16)and $F;
    ComboBox8.ItemIndex:= (DATA shr 12)and $F;
    ComboBox7.ItemIndex:= (DATA shr  8)and $F;
    ComboBox6.ItemIndex:= (DATA shr  4)and $F;
    ComboBox5.ItemIndex:=  DATA and $F;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
    if checkbox2.Checked then
    begin //  
        checkbox3.Enabled:=false;
        LTR43.StreamReadRate:=strtoint(edit1.Text);
        err:=LTR43_Config(@LTR43);
        if TESTERROR(err,memo1,'  43')then exit;
        GODCounter:=0;
        LTR43_StartStreamRead(@LTR43);
        Timer2.Enabled:=true;
        edit1.Text:=floattostr(LTR43.StreamReadRate);
    end else
    begin //  
        checkbox3.Enabled:=true;
        Timer2.Enabled:=false;
        LTR43_StopStreamRead(@LTR43);
    end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var DATA:integer;
begin
if(LTR43ONLINE)then
begin
   DATA:=LTR43.Channel.tmark;
   Edit2.Text:=IntToStr(DATA SHR 16);
   Edit3.Text:=IntToStr(DATA and $FFFF);
end;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
var erRr:integer;
    i:integer;
    f:textFile;
    TMARK_STR:string;
    //DATA_BUF :array[0..20000]of cardinal;
    //TMARK_BUF:array[0..20000]of cardinal;
begin
  for i:=0 to 20000 do
  begin
   TMARK_BUF[i]:=0;
   DATA_BUF[i]:=0;
  end;

  erRr:=LTR43_Recv(@LTR43,@DATA_BUF,@TMARK_BUF,strToint(Edit1.text)*2,20000);
  GODCounter:=GODCounter+erRr;
  TESTERROR(err,memo1,'   : '+inttostr(erRr)+'.   '+' : '+inttostr(GODCounter)+'.');
  if(erRr<strToint(Edit1.text)*2)then
  begin
    Memo1.Lines.Add(' :     !');
    Memo1.Lines.Add(' :                       ');
    for i:=erRr-16 to erRr+16 do
    begin
       TMARK_STR:=char(IntTohexchar(TMARK_BUF[i],7))+char(IntTohexchar(TMARK_BUF[i],6))+char(IntTohexchar(TMARK_BUF[i],5))+char(IntTohexchar(TMARK_BUF[i],4))+char(IntTohexchar(TMARK_BUF[i],3))+char(IntTohexchar(TMARK_BUF[i],2))+char(IntTohexchar(TMARK_BUF[i],1))+char(IntTohexchar(TMARK_BUF[i],0));
       Memo1.Lines.Add('  '+Inttostr(GODCounter+i)+'    '+Inttostr(i)+'     :     '+char(IntTohexchar(DATA_BUF[i],7))+char(IntTohexchar(DATA_BUF[i],6))+char(IntTohexchar(DATA_BUF[i],5))+char(IntTohexchar(DATA_BUF[i],4))+char(IntTohexchar(DATA_BUF[i],3))+char(IntTohexchar(DATA_BUF[i],2))+char(IntTohexchar(DATA_BUF[i],1))+char(IntTohexchar(DATA_BUF[i],0))+'       '+TMARK_STR);
    end;

    Timer2.Enabled:=false;
    LTR43_StopStreamRead(@LTR43);
  end;

  err:=LTR43_ProcessData(@LTR,@DATA_BUF,@TMARK_BUF,@erRr);
  TESTERROR(err,memo1,' :   '+inttostr(erRr));
  if(err=-4046)then
  begin
    Memo1.Lines.Add(':   '+inttostr(err)+'    :'+ inttostr(erRr)+' :');
    for i:=0 to 2001 do
    begin
      TMARK_STR:=char(IntTohexchar(TMARK_BUF[i],7))+char(IntTohexchar(TMARK_BUF[i],6))+char(IntTohexchar(TMARK_BUF[i],5))+char(IntTohexchar(TMARK_BUF[i],4))+char(IntTohexchar(TMARK_BUF[i],3))+char(IntTohexchar(TMARK_BUF[i],2))+char(IntTohexchar(TMARK_BUF[i],1))+char(IntTohexchar(TMARK_BUF[i],0));
      Memo1.Lines.Add(':'+inttostr(i)+'  '+char(IntTohexchar(DATA_BUF[i],7))+char(IntTohexchar(DATA_BUF[i],6))+char(IntTohexchar(DATA_BUF[i],5))+char(IntTohexchar(DATA_BUF[i],4))+char(IntTohexchar(DATA_BUF[i],3))+char(IntTohexchar(DATA_BUF[i],2))+char(IntTohexchar(DATA_BUF[i],1))+char(IntTohexchar(DATA_BUF[i],0))+'     MARK:  '+TMARK_STR);
    end;
    Timer2.Enabled:=false;
    LTR43_StopStreamRead(@LTR43);
  end;


end;

procedure TForm1.CheckBox3Click(Sender: TObject);
var i:integer;
begin

  if checkbox3.Checked then
  begin
    for i:=0 to 255 do
    DATA_BUF[i]:=i+(i shl 8)+(i shl 16) + (i shl 24);

    checkbox2.Enabled:=false;
    GODCounter:=0;
    Timer3.Enabled:=true;
  end else
  begin
    checkbox2.Enabled:=true;
    Timer3.Enabled:=false;
  end;
end;

procedure TForm1.Timer3Timer(Sender: TObject);
begin
  err:=LTR43_WriteArray(@LTR43,@DATA_BUF,255);
  if TESTERROR(err,memo1,'    :  255 .   '+' : '+inttostr(GODCounter)+'.') then
  begin
      Memo1.Lines.Add('    ,   !!!');
      Timer3.Enabled:=false;
      Checkbox3.Checked:=false;
  end;
  GODCounter:=GODCounter+255;
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
  if checkbox4.Checked then
  begin
    Timer4.Enabled:=true;
  end else
  begin
    Timer4.Enabled:=false;
  end;
end;

procedure TForm1.Timer4Timer(Sender: TObject);
var DATA:integer;
begin
    DATA:=$DEEDEEE;
    err:=LTR43_WritePort(@LTR43,DATA);
    if TESTERROR(err,memo1,'     ...')then
    begin

        Memo1.Lines.Add('!!!     !!!');
        Timer4.Enabled:=false;
        Checkbox4.Checked:=false;
    end;
end;

procedure TForm1.Timer5Timer(Sender: TObject);
var DATA:integer;
begin
    err:=LTR43_ReadPort(@LTR43,@DATA);
    if TESTERROR(err,memo1,'  ')then
    begin
        Memo1.Lines.Add('!!!     !!!');
        Timer5.Enabled:=false;
        Checkbox5.Checked:=false;
    end;
end;

procedure TForm1.CheckBox5Click(Sender: TObject);
begin
  if checkbox5.Checked then
  begin
    Timer5.Enabled:=true;
  end else
  begin
    Timer5.Enabled:=false;
  end;
end;

function eval_parity(cmd:Cardinal):integer;
var
  index:Longword;//  64 ....
  parity,i:integer;

begin
  parity:=0;
	for i:=0 to 4 do
  begin
     index:=1 shl i;

		 parity:=parity xor ord((cmd and index) <> 0);
  end;
	//        
	for i:=0 to 15 do
  begin
    //  (index = 0x80000000UL; index >= 0x00010000UL; index >>= 1)
    index:=$80000000 shr i;
		parity:=parity xor ord((cmd and index) <> 0);
  end;
	eval_parity:=parity;
end;


procedure TForm1.Button6Click(Sender: TObject);
begin
end;

{begin
    LTR43.RS485.FrameSize:=Spinedit1.Value;
    LTR43.RS485.Baud:=115200;
    LTR43.RS485.StopBit:=0;
    LTR43.RS485.Parity:=0;
    //   ...
end;}

procedure TForm1.Timer6Timer(Sender: TObject);
var
  err,i:integer;
  command_ask:array[0..5000]of DWORD;
  TIME_ack:array[0..5000]of DWORD;
begin
  err:=LTR_Recv(@LTR43.channel, @command_ask, @TIME_ack, 5000, 6000);
  if(err>0)then
  begin
     for i:=0 to 10 do
     Memo1.Lines.Add(': '+char(IntTohexchar(command_ask[i],3))+char(IntTohexchar(command_ask[i],2))+char(IntTohexchar(command_ask[i],1))+char(IntTohexchar(command_ask[i],0)));
  end else
  begin
     Memo1.Lines.Add(' '+inttostr(err));
  end;
end;

end.
